/*
 * Common header file for twcw.c and sendCW.c
 */
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <sys/msg.h>
#include <stdio.h>
#include <errno.h>

/*
 * Common Defines
 */
#define WPM_DONE         7L      /* Done calabrating WPM */
#define SENT_MSG         6L      /* Send text to be displayed by the GUI */
/* The two message types above are only read by twcw */

/* The message types below are only read by sendCW */
/* and are processed in 1 -> 5 order */
#define WORD_MSG         5L      /* Read text to send */
#define STOP_MSG         4L      /* Stop sending  */
#define TONE_MSG         3L      /* Set sidetone frequency*/
#define SIDETONE_MSG     2L      /* Turn sidetone on of off*/
#define WPM_MSG          1L      /* Set new WPM */

#define TWCW_KEY         73      /* Message Queue Key */
#define MAX_WORD_LENGTH  20      /* Maximum length of a word */

/*
 * Message Queue Structure
 */
struct tag1
{
   long type;
   union
      {
          unsigned char word[MAX_WORD_LENGTH];
          int  val;
      } data;
};
