/*
 *  Header file for sendCW
 */

/* #Defines and Header Files */
#define ON   1
#define OFF  0
#define TRUE 1
#define FALSE !TRUE
#define DIT '.'
#define DAH '-'
#define MAX_LETTERS 512
#define _USE_BSD

#include <stdlib.h>
#include <unistd.h>	
#include <sys/kd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/resource.h>

/* 
 * Global Variables
 */
int  qid;                              /* Message queue id */
int  confd;                            /* File descriptor for sidetone */
int  serfd;                            /* File descriptor for serial port */
int  tone;                             /* To be adjustable? */
int  wpm;                              /* Speed in WPM */
unsigned char *letters[MAX_LETTERS];   /* Array for morse characters */

long  dit_time;                        /* Dit time in uSEC */
long  dah_time;                        /* Dah time in uSEC */
long  ic_time;                         /* Intra char time == dit_time */
long  il_time;                         /* Inter char time == dah_time */
long  iw_time;                         /* Inter word time */
  
/*
 * Function Declarations
 */
int  initialize (float cpu_clock, char *ser_dev);
int  probe_clock (float cpu_clock);
void cleanup ();
void SetWPM (int new_speed, float cpu_clock, int rdtsc_ok);
void SetTone (int new_tone);
void SetSidetone (int new_tone);
void DoWord (unsigned char[], float cpu_clock, int key, int rdtsc_ok);
void DoLetter (char[], float cpu_cpeed, int key, int rdtsc_ok);
void PlayBeep (int time, float cpu_clock, int key, int rdtsc_ok);
void timer (long usec, float cpu_clock, int rdtsc_ok);
pid_t wait4 (pid_t, int *, int, struct rusage *);   /*Why?*/
/* void usleep(unsigned long usec); */
