/*
 * twcw.h Header File
 */

/*
 * Include Files
 */

#include <ctype.h>
#include <stdlib.h>
#include <locale.h> 
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <X11/cursorfont.h>
#include <Xm/Form.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/Scale.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/RowColumn.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/DialogS.h>
#include <Xm/SelectioB.h>
#include <Xm/MessageB.h>
#include <Xm/Separator.h>
#include <Xm/MwmUtil.h>
#include <X11/StringDefs.h>
#include <X11/xpm.h>

/*
 * Define Values
 */
#define TWCWDIR          "/twcwDir"  /* These two need the starting / */
#define HELPFILE         "/twcwHelp"

#define TEXTF1_LEN       40      /* Length of textF1 in characters */
#define MIN_WPM           8      /* Minimum words per minute */
#define MAX_WPM          50      /* Maximum words per minute */

#define CLR_TEXT          0      /* Client Data for popupCB */
#define CLR_SEND          1      /* and buttons on Menu bar's Edit button*/
#define RESET             2
#define QRT               3      

/*
 * Application Defined Resources
 */
#define XmNcall            "call"
#define XmCCall            "Call"

#define XmNbuttonNames     "buttonNames"
#define XmCButtonNames     "ButtonNames"

#define XmNcpuSpeed        "cpuSpeed"
#define XmCCpuSpeed        "CpuSpeed"

#define XmNserialDevice    "serialDevice"
#define XmCSerialDevice    "SerialDevice"

typedef struct
   {
   char *call;
   char **buttonNames;
   char *cpuSpeed;
   char *serialDevice;
   } AppRes;
  
/* 
 * Globals Variables
 */
XtAppContext ac;
Widget shell, tb1, tb2, scale1;
Widget text1, textf1, textf2;

int  qid;                      /* Message queue id */
int  pid;                      /* Child process id */

char dirpath[100];
char helppath[100];

/*
 * Function Declarations
 */
void    build_widgets (Widget, AppRes *);
void    popupCB (Widget, XtPointer, XtPointer);
void    text1CB (Widget, XtPointer, XtPointer);
void    textf1CB (Widget, XtPointer, XtPointer);
void    textf2CB (Widget, XtPointer, XtPointer);
int     DoProSigns(XmTextVerifyCallbackStruct *, int);
void    MkRoom (XmTextVerifyCallbackStruct *, int);
void    fileCB (Widget, XtPointer, XtPointer);
char    *getFile (char *);
void    tb1CB (Widget, XtPointer, XtPointer);
void    tb2CB (Widget, XtPointer, XtPointer);
void    OkCB (Widget, XtPointer, XtPointer);
void    cancelCB (Widget, XtPointer, XtPointer);
void    input_event (Widget, XtPointer, XEvent *, Boolean *);
void    aboutCB (Widget, XtPointer, XtPointer);
void    helpCB (Widget, XtPointer, XtPointer);
void    scale1CB (Widget, XtPointer, XtPointer);
void    quitCB (Widget, XtPointer, XtPointer);
Boolean procData (XtPointer);
void    inputDiag (char *);
int     setup (void);
int     send_msg (long int, char *);
void    cleanup ();
int     fork_sendCW (char *, char *);
Boolean do_work (XtPointer);
void    sendOver (Widget w, XEvent *e, String args[], Cardinal *nargs);
void    sendHisCall (Widget w, XEvent *e, String args[], Cardinal *nargs);
void    sendMacro (Widget w, XEvent *e, String args[], Cardinal *nargs);
char    *getHisCall ();
void    procMacroText (char *ch);
